package org.processmining.changepatterns.algorithms.modelchanges.abstr;

import org.processmining.plugins.etm.model.narytree.NAryTree;

public abstract class ChangePatternAbstr implements ChangePattern {

	protected int getRandomLeafIndex(NAryTree naryTree) {
		int index = 0;
		while (true) {
			index = (int) Math.floor((Math.random() * naryTree.size()));
			if (naryTree.isLeaf(index) && naryTree.getType(index) != NAryTree.TAU)
				return index;
		}
	}

	protected int getRandomNodeIndex(NAryTree naryTree) {
		int index = 0;
		while (true) {
			index = (int) Math.floor(Math.random() * naryTree.size());
			if (!naryTree.isLeaf(index) && naryTree.getType(index) != NAryTree.LOOP)
				return index;
		}
	}
}
